namespace StudySystemClient.Request {
	public class Request {
		private Der.Datum datum;

		public Request(uint16 transaction_id, Body body) {
			datum = new Der.Sequence(
				{ new Der.Integer(transaction_id), body.datum });
		}

		public uint8[] encode() {
			return datum.encode();
		}
	}

	public abstract class Body {
		protected enum Tag {
			PING = 0,
			LIST_PRIORITIZED_ACTIVITIES = 1,
			LOG_SESSION = 2,
		}

		internal Der.Datum datum;
	}

	public class Ping : Body {
		public Ping() {
			datum = new Der.Choice(Tag.PING, new Der.Null());
		}
	}
}
